<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class IntegracaoSMFactory  {

    use TQuery;
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function validaInsertLocalCli(array $params) {

        $sql = "SELECT COUNT(*) VALIDA 
                  FROM FCM_LOCALCLI
                 WHERE CDCLIENTE = :CDCLIENTE 
                   AND NRESTRUTURAM = :NRESTRUTURAM
                   AND NRORG = :NRORG";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params); 
        $retorno = $std->fetchAll();
        return $retorno[0]["VALIDA"];        
    }

    public function cadastrarLocais(array $params) {

        $sql = "INSERT INTO FCM_LOCALCLI (NRLOCALCLIENTE, NMLOCALCLIENTE, CDCLIENTE, NRTIPOLOCALCLI, NRESTRUTURAM,
                                          IDATIVO, NRORG, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO)
                     VALUES (:NRLOCALCLIENTE, :NMLOCALCLIENTE, :CDCLIENTE, :NRTIPOLOCALCLI, :NRESTRUTURAM,
                              'S', :NRORG, SYSDATE, :OPERADOR, :NRORG)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);        
    }

    public function getDadosMedicao(array $params) {

        $sql = "SELECT NRSEQCONTRATO, NRMEDICAOFATURA, CDSERVORCA AS SERVICO, CDTPMEDIDASERV AS MEDIDA, SUM(DURACAO) AS QTMEDIDA,
                      NRCHECKLISTAGEND,  NRLOCALCLIENTE, NRCHECKLIST, DTHORAAGEND, DTHRFINALAGEND
               FROM (
               SELECT DISTINCT FCM_CHECKLISTAGEND.NRCHECKLISTAGEND, FCM_CHECKLISTAGEND.NRLOCALCLIENTE, FCM_CHECKLISTAGEND.NRCHECKLIST, 
                TO_CHAR(FCM_CHECKLISTAGEND.DTHORAAGEND, 'DD/MM/YYYY  HH24:MI:SS') AS DTHORAAGEND, TO_CHAR(FCM_CHECKLISTAGEND.DTHRFINALAGEND, 'DD/MM/YYYY  HH24:MI:SS') AS DTHRFINALAGEND, 
                ROUND(((DTHRFINALAGEND - DTHORAAGEND) * 24), 2) AS DURACAO, FCM_CHECKLISTAGEND.NRSEQCONTRATO, FCT_MEDICAOFATURA.NRMEDICAOFATURA, FCM_RELSERVITEMTAR.CDSERVORCA, FCM_RELSERVITEMTAR.CDTPMEDIDASERV
                  FROM FCM_CHECKLISTAGEND
                  JOIN FCT_MEDICAOFATURA
                    ON FCT_MEDICAOFATURA.NRSEQCONTRATO = FCM_CHECKLISTAGEND.NRSEQCONTRATO
                  JOIN FCT_MEDVARMEDICAOFATURA
                    ON FCT_MEDVARMEDICAOFATURA.NRMEDICAOFATURA = FCT_MEDICAOFATURA.NRMEDICAOFATURA
                  JOIN FCM_RELSERVITEMTAR
                    ON FCM_RELSERVITEMTAR.CDSERVORCA = FCT_MEDVARMEDICAOFATURA.CDSERVORCA
                   AND FCM_RELSERVITEMTAR.CDTPMEDIDASERV = FCT_MEDVARMEDICAOFATURA.CDTPMEDIDAVARIAVEL
                  JOIN FCM_ATIVIDADECHK
                    ON FCM_ATIVIDADECHK.NRCHECKLIST = FCM_CHECKLISTAGEND.NRCHECKLIST
                   AND FCM_ATIVIDADECHK.NRATIVIDADE = FCM_RELSERVITEMTAR.NRATIVIDADE
                  JOIN FCM_TAREFACHK
                    ON FCM_TAREFACHK.NRATIVIDADECHK = FCM_ATIVIDADECHK.NRATIVIDADECHK
                   AND FCM_TAREFACHK.NRCHECKLIST = FCM_CHECKLISTAGEND.NRCHECKLIST
                   JOIN FCM_TAREFAAGEND
                    ON FCM_TAREFAAGEND.NRCHECKLISTAGEND = FCM_CHECKLISTAGEND.NRCHECKLISTAGEND
                   AND FCM_TAREFAAGEND.NRTAREFACHK = FCM_TAREFACHK.NRTAREFACHK
                 WHERE FCM_CHECKLISTAGEND.NRSEQCONTRATO = :NRSEQCONTRATO
                   AND FCT_MEDICAOFATURA.NRMEDICAOFATURA = :NRMEDICAOFATURA
                   AND FCT_MEDICAOFATURA.NRORG = :NRORG
                   AND (FCM_CHECKLISTAGEND.DTHORAAGEND BETWEEN FCT_MEDICAOFATURA.DTINICOMPET AND FCT_MEDICAOFATURA.DTFINCOMPET) 
                   AND FCM_TAREFAAGEND.IDREALIZADO = 'S') MEDICAO
                GROUP BY  NRSEQCONTRATO, NRMEDICAOFATURA, CDSERVORCA, CDTPMEDIDASERV,
                      NRCHECKLISTAGEND,  NRLOCALCLIENTE, NRCHECKLIST, DTHORAAGEND, DTHRFINALAGEND";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();        
    }

}

?>